.build-kivy-appimage:
    variables:
        PYTHON_VERSION: "cp312-cp312"
        KIVY_VERSION: "2.3.0"
        CFLAGS: "-Wno-incompatible-pointer-types"
    image: registry.gitlab.com/memetis/ci-cd/build-scripts/kivybuild:${POLICY}-${PLATFORM}
    stage: build-kivy-appimage
    script:
        - mkdir build
        - cd build
        - curl -L -o appimagetool "https://gitlab.com/api/v4/projects/memetis%2Fci-cd%2Fbuild-scripts/packages/generic/appimagetool/${POLICY}/appimagetool_${PLATFORM}.AppImage"
        - chmod +x appimagetool
        - curl -L -o python_appimage "https://gitlab.com/api/v4/projects/memetis%2Fci-cd%2Fbuild-scripts/packages/generic/python/${POLICY}/python_${PYTHON_VERSION}_${PLATFORM}.AppImage"
        - chmod +x python_appimage
        - export APPIMAGE_EXTRACT_AND_RUN=1
        - export PYTHONNOUSERSITE=1
        - export KIVY_DEPS_ROOT="/kivy-dependencies"
        - ./python_appimage --appimage-extract
        - mv squashfs-root app
        - ./app/AppRun -m pip install --no-binary "kivy" "kivy[base]==${KIVY_VERSION}"
        - rm -r app/opt/python*/share/kivy-examples
        - cp -rTv /kivy-dependencies/dist/ app/usr/ || true
        - ./appimagetool app kivy_${PYTHON_VERSION}_${KIVY_VERSION}_${PLATFORM}.AppImage
        - ./kivy*.AppImage --version
        - 'curl --header "JOB-TOKEN: $CI_JOB_TOKEN" --upload-file kivy*.AppImage "${CI_API_V4_URL}/projects/${CI_PROJECT_ID}/packages/generic/kivy/${POLICY}/kivy_${PYTHON_VERSION}_${KIVY_VERSION}_${PLATFORM}.AppImage"'

build-kivy-appimage-rpi32:
    variables:
        POLICY: "manylinux_2_24"
        PLATFORM: "armv7l"
    extends:
        - .build-kivy-appimage
    tags:
      - rpi32

build-kivy-appimage-rpi64:
    variables:
        POLICY: "manylinux_2_24"
        PLATFORM: "aarch64"
    extends:
        - .build-kivy-appimage
    tags:
        - rpi64

build-kivy-appimage-linux:
    variables:
        POLICY: "manylinux_2_24"
        PLATFORM: "x86_64"
    extends:
        - .build-kivy-appimage
    tags:
        - linux
